Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3791)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3792)
@@ -3492,26 +1573,8 @@
        ENDDO
        kctw = kk - 1
-!AH
-       write(9,"('kcto, kctw = ', 2(i3,2x))") kcto, kctw
-
-!AH
-!       ALLOCATE( iflu(icl:icr) )
-!       ALLOCATE( iflo(icl:icr) )
-!       ALLOCATE( ifuu(icl:icr) )
-!       ALLOCATE( ifuo(icl:icr) )
-!       ALLOCATE( jflv(jcs:jcn) )
-!       ALLOCATE( jflo(jcs:jcn) )
-!       ALLOCATE( jfuv(jcs:jcn) )
-!       ALLOCATE( jfuo(jcs:jcn) )
-!       
-!       ALLOCATE( iflu(icl-1:icr+1) )
-!       ALLOCATE( iflo(icl-1:icr+1) )
-!       ALLOCATE( ifuu(icl-1:icr+1) )
-!       ALLOCATE( ifuo(icl-1:icr+1) )
-!       ALLOCATE( jflv(jcs-1:jcn+1) )
-!       ALLOCATE( jflo(jcs-1:jcn+1) )
-!       ALLOCATE( jfuv(jcs-1:jcn+1) )
-!       ALLOCATE( jfuo(jcs-1:jcn+1) )
-!
+
+       WRITE(9,"('kcto, kctw = ', 2(i3,2x))") kcto, kctw
+       FLUSH(9)
+       
        icla = coarse_bound_aux(1)
        icra = coarse_bound_aux(2)
@@ -3526,25 +1589,12 @@
        ALLOCATE( jfuv(jcsa:jcna) )
        ALLOCATE( jfuo(jcsa:jcna) )       
-!AH
        ALLOCATE( kflw(0:cg%nz+1) )
        ALLOCATE( kflo(0:cg%nz+1) )
        ALLOCATE( kfuw(0:cg%nz+1) )
        ALLOCATE( kfuo(0:cg%nz+1) )
-!AH
-!       ALLOCATE( ijkfc_u(0:cg%nz+1,jcs:jcn,icl:icr) )
-!       ALLOCATE( ijkfc_v(0:cg%nz+1,jcs:jcn,icl:icr) )
-!       ALLOCATE( ijkfc_w(0:cg%nz+1,jcs:jcn,icl:icr) )
-!       ALLOCATE( ijkfc_s(0:cg%nz+1,jcs:jcn,icl:icr) )
-!
-!       ALLOCATE( ijkfc_u(0:cg%nz+1,jcs-1:jcn+1,icl-1:icr+1) )
-!       ALLOCATE( ijkfc_v(0:cg%nz+1,jcs-1:jcn+1,icl-1:icr+1) )
-!       ALLOCATE( ijkfc_w(0:cg%nz+1,jcs-1:jcn+1,icl-1:icr+1) )
-!       ALLOCATE( ijkfc_s(0:cg%nz+1,jcs-1:jcn+1,icl-1:icr+1) )
-!
        ALLOCATE( ijkfc_u(0:cg%nz+1,jcsa:jcna,icla:icra) )
        ALLOCATE( ijkfc_v(0:cg%nz+1,jcsa:jcna,icla:icra) )
        ALLOCATE( ijkfc_w(0:cg%nz+1,jcsa:jcna,icla:icra) )
        ALLOCATE( ijkfc_s(0:cg%nz+1,jcsa:jcna,icla:icra) )
-!AH
 
        ijkfc_u = 0
@@ -3568,10 +1618,9 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          write(9,"('pmci_init_anterp_tophat, ii, iflu, ifuu: ', 3(i4,2x))")    &
+          WRITE(9,"('pmci_init_anterp_tophat, ii, iflu, ifuu: ', 3(i4,2x))")    &
                ii, iflu(ii), ifuu(ii)
-          flush(9)
-
+          FLUSH(9)
        ENDDO
-       write(9,*)
+       WRITE(9,*)
 !
 !--    i-indices of others for each ii-index value
@@ -3594,9 +1643,9 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          write(9,"('pmci_init_anterp_tophat, ii, iflo, ifuo: ', 3(i4,2x))")    &
+          WRITE(9,"('pmci_init_anterp_tophat, ii, iflo, ifuo: ', 3(i4,2x))")    &
                ii, iflo(ii), ifuo(ii)
-          flush(9)
+          FLUSH(9)
        ENDDO
-       write(9,*)
+       WRITE(9,*)
 !
 !--    j-indices of v for each jj-index value
@@ -3615,9 +1664,9 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          write(9,"('pmci_init_anterp_tophat, jj, jflv, jfuv: ', 3(i4,2x))")    &
+          WRITE(9,"('pmci_init_anterp_tophat, jj, jflv, jfuv: ', 3(i4,2x))")    &
                jj, jflv(jj), jfuv(jj)
-          flush(9)
+          FLUSH(9)
        ENDDO
-       write(9,*)
+       WRITE(9,*)
 !
 !--    j-indices of others for each jj-index value
@@ -3640,9 +1689,9 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          write(9,"('pmci_init_anterp_tophat, jj, jflo, jfuo: ', 3(i4,2x))")    &
+          WRITE(9,"('pmci_init_anterp_tophat, jj, jflo, jfuo: ', 3(i4,2x))")    &
                jj, jflo(jj), jfuo(jj)
-          flush(9)
+          FLUSH(9)
        ENDDO
-       write(9,*)
+       WRITE(9,*)
 !
 !--    k-indices of w for each kk-index value
@@ -3665,9 +1714,9 @@
 !
 !--       Print out the index bounds for checking and debugging purposes
-          write(9,"('pmci_init_anterp_tophat, kk, kflw, kfuw: ', 4(i4,2x), 2(e12.5,2x))") &
+          WRITE(9,"('pmci_init_anterp_tophat, kk, kflw, kfuw: ', 4(i4,2x), 2(e12.5,2x))") &
                kk, kflw(kk), kfuw(kk), nzt,  cg%zu(kk), cg%zw(kk)
-          flush(9)
+          FLUSH(9)
        ENDDO
-       write(9,*)
+       WRITE(9,*)
 !
 !--    k-indices of others for each kk-index value
@@ -3692,29 +1741,23 @@
        ENDDO
 !
-!--    Set the k-index bounds separately for the parent-grid cells cg%nz and cg%nz+1. 
-!--    Index bounds for cg%nz are needed for the reversibility correction.
-       kflo(cg%nz)   = nzt+1    ! Needed for the reversibility correction
-       kfuo(cg%nz)   = nzt+kgsr ! Needed for the reversibility correction
-       kflo(cg%nz+1) = nzt+kgsr ! Obsolete
-       kfuo(cg%nz+1) = nzt+kgsr ! Obsolete 
-!
-!--       Print out the index bounds for checking and debugging purposes
+!--    Set the k-index bounds separately for the parent-grid cells cg%nz and cg%nz+1       
+!--    although they are not actually needed.
+       kflo(cg%nz)   = nzt+1    
+       kfuo(cg%nz)   = nzt+kgsr 
+       kflo(cg%nz+1) = nzt+kgsr 
+       kfuo(cg%nz+1) = nzt+kgsr 
+!
+!--    Print out the index bounds for checking and debugging purposes
        DO  kk = 1, cg%nz+1
-          write(9,"('pmci_init_anterp_tophat, kk, kflo, kfuo: ', 4(i4,2x), 2(e12.5,2x))") &
+          WRITE(9,"('pmci_init_anterp_tophat, kk, kflo, kfuo: ', 4(i4,2x), 2(e12.5,2x))") &
                kk, kflo(kk), kfuo(kk), nzt,  cg%zu(kk), cg%zw(kk)
-          flush(9)
+          FLUSH(9)
        ENDDO
-       write(9,*)
+       WRITE(9,*)
 !
 !--    Precomputation of number of fine-grid nodes inside parent-grid cells.
 !--    Note that ii, jj, and kk are parent-grid indices. 
 !--    This information is needed in anterpolation and in reversibility 
-!--    correction in interpolation. For the reversibility correction, ijkfc-
-!--    information is needed also beyond the indices for wall_flags_0-masking 
-!--    must be modified here in the boundary-normal direction (iw, jw, kw). 
-!AH       DO  ii = icl, icr
-!AH          DO  jj = jcs, jcn
-!AH       DO  ii = icl-1, icr+1
-!AH          DO  jj = jcs-1, jcn+1
+!--    correction in interpolation. 
        DO  ii = icla, icra
           DO  jj = jcsa, jcna
@@ -3776,48 +1819,92 @@
           ENDDO  ! jj
        ENDDO  ! ii
-!
-!--    Spatial under-relaxation coefficients
-       ALLOCATE( frax(icl:icr) )
-       ALLOCATE( fray(jcs:jcn) )
+
+    END SUBROUTINE pmci_define_index_mapping
+    
+
+
+    SUBROUTINE pmci_allocate_workarrays
+!
+!--    Allocate parent-grid work-arrays for interpolation
+       IMPLICIT NONE
+
+!
+!--    Determine and store the PE-subdomain dependent index bounds
+       IF  ( bc_dirichlet_l )  THEN
+          iclw = icl + 1
+       ELSE
+          iclw = icl - 1
+       ENDIF
+
+       IF  ( bc_dirichlet_r )  THEN
+          icrw = icr - 1
+       ELSE
+          icrw = icr + 1
+       ENDIF
+
+       IF  ( bc_dirichlet_s )  THEN
+          jcsw = jcs + 1
+       ELSE
+          jcsw = jcs - 1
+       ENDIF
+
+       IF  ( bc_dirichlet_n )  THEN
+          jcnw = jcn - 1
+       ELSE
+          jcnw = jcn + 1
+       ENDIF
+    
+       coarse_bound_w(1) = iclw
+       coarse_bound_w(2) = icrw
+       coarse_bound_w(3) = jcsw
+       coarse_bound_w(4) = jcnw
+!
+!--    Left and right boundaries.
+       ALLOCATE( workarrc_lr(0:cg%nz+1,jcsw:jcnw,0:2) )
+!
+!--    South and north boundaries.
+       ALLOCATE( workarrc_sn(0:cg%nz+1,0:2,iclw:icrw) )
+!
+!--    Top boundary.
+!AH       ALLOCATE( workarrc_t(0:2,jcsw:jcnw,iclw:icrw) )
+       ALLOCATE( workarrc_t(-2:3,jcsw:jcnw,iclw:icrw) )
+
+    END SUBROUTINE pmci_allocate_workarrays
+
+
+
+    SUBROUTINE pmci_create_workarray_exchange_datatypes
+!
+!--    Define specific MPI types for workarrc-exhchange.
+       IMPLICIT NONE
+
+#if defined( __parallel )       
+!
+!--    For the left and right boundaries
+       CALL MPI_TYPE_VECTOR( 3, cg%nz+2, (jcnw-jcsw+1)*(cg%nz+2), MPI_REAL,     &
+            workarrc_lr_exchange_type, ierr )
+       CALL MPI_TYPE_COMMIT( workarrc_lr_exchange_type, ierr )
+!
+!--    For the south and north boundaries
+       CALL MPI_TYPE_VECTOR( 1, 3*(cg%nz+2), 3*(cg%nz+2), MPI_REAL,             &
+            workarrc_sn_exchange_type, ierr )
+       CALL MPI_TYPE_COMMIT( workarrc_sn_exchange_type, ierr )
+!
+!--    For the top-boundary x-slices
+!AH       CALL MPI_TYPE_VECTOR( icrw-iclw+1, 3, 3*(jcnw-jcsw+1), MPI_REAL,         &
+!AH            workarrc_t_exchange_type_x, ierr )
+       CALL MPI_TYPE_VECTOR( icrw-iclw+1, 6, 6*(jcnw-jcsw+1), MPI_REAL,         &
+            workarrc_t_exchange_type_x, ierr )
+       CALL MPI_TYPE_COMMIT( workarrc_t_exchange_type_x, ierr )
+!
+!--    For the top-boundary y-slices
+!AH       CALL MPI_TYPE_VECTOR( 1, 3*(jcnw-jcsw+1), 3*(jcnw-jcsw+1), MPI_REAL,     &
+!AH            workarrc_t_exchange_type_y, ierr )
+       CALL MPI_TYPE_VECTOR( 1, 6*(jcnw-jcsw+1), 6*(jcnw-jcsw+1), MPI_REAL,     &
+            workarrc_t_exchange_type_y, ierr )
+       CALL MPI_TYPE_COMMIT( workarrc_t_exchange_type_y, ierr )
+#endif
        
-       frax(icl:icr) = 1.0_wp
-       fray(jcs:jcn) = 1.0_wp
-
-!AH       IF ( nesting_mode /= 'vertical' )  THEN
-!AH          DO  ii = icl, icr
-!AH             IF ( ifuu(ii) < ( nx + 1 ) / 2 )  THEN   
-!AH                xi = ( MAX( 0.0_wp, ( cg%coord_x(ii) -                         &
-!AH                     lower_left_coord_x ) ) / anterp_relax_length_l )**4
-!AH                frax(ii) = xi / ( 1.0_wp + xi )
-!AH             ELSE
-!AH                xi = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx -   &
-!AH                                      cg%coord_x(ii) ) ) /                     &
-!AH                       anterp_relax_length_r )**4
-!AH                frax(ii) = xi / ( 1.0_wp + xi )                
-!AH             ENDIF
-!AH          ENDDO
-!AH
-!AH          DO  jj = jcs, jcn
-!AH             IF ( jfuv(jj) < ( ny + 1 ) / 2 )  THEN 
-!AH                eta = ( MAX( 0.0_wp, ( cg%coord_y(jj) -                        &
-!AH                     lower_left_coord_y ) ) / anterp_relax_length_s )**4
-!AH                fray(jj) = eta / ( 1.0_wp + eta )
-!AH             ELSE
-!AH                eta = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy -  &
-!AH                                       cg%coord_y(jj)) ) /                     &
-!AH                        anterp_relax_length_n )**4
-!AH                fray(jj) = eta / ( 1.0_wp + eta )
-!AH             ENDIF
-!AH          ENDDO
-!AH       ENDIF
-      
-       ALLOCATE( fraz(0:kcto) )
-       fraz(0:kcto) = 1.0_wp
-!AH       DO  kk = 0, kcto
-!AH          zeta = ( ( zu(nzt) - cg%zu(kk) ) / anterp_relax_length_t )**4
-!AH          fraz(kk) = zeta / ( 1.0_wp + zeta )
-!AH       ENDDO
-
-    END SUBROUTINE pmci_init_anterp_tophat
+    END SUBROUTINE pmci_create_workarray_exchange_datatypes
 
 
@@ -3921,5 +2008,4 @@
      END SUBROUTINE pmci_check_grid_matching
 
-
 #endif  
  END SUBROUTINE pmci_setup_child
@@ -4000,4 +2086,5 @@
        pmc_max_array = pmc_max_array + nspec
 #endif
+    
  END SUBROUTINE pmci_num_arrays
 
@@ -4012,8 +2099,8 @@
     INTEGER(iwp), INTENT(IN),OPTIONAL ::  n           !< index of chemical species
 
-    CHARACTER(LEN=*), INTENT(IN) ::  name        !<
+    CHARACTER(LEN=*), INTENT(IN) ::  name             !<
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  ierr        !<
+    INTEGER(iwp) ::  ierr                            !< MPI error code
 
     REAL(wp), POINTER, DIMENSION(:,:)     ::  p_2d        !<
@@ -4027,5 +2114,4 @@
     NULLIFY( p_2d )
     NULLIFY( i_2d )
-
 !
 !-- List of array names, which can be coupled.
@@ -4046,10 +2132,8 @@
     IF ( TRIM(name) == "part_adr"   )  i_2d => part_adr
     IF ( INDEX( TRIM(name), "chem_" ) /= 0 )  p_3d => chem_species(n)%conc
-
 !
 !-- Next line is just an example for a 2D array (not active for coupling!)
 !-- Please note, that z0 has to be declared as TARGET array in modules.f90
 !    IF ( TRIM(name) == "z0" )    p_2d => z0
-
     IF ( TRIM(name) == "u"    )  p_3d_sec => u_2
     IF ( TRIM(name) == "v"    )  p_3d_sec => v_2
@@ -4094,5 +2178,5 @@
 
 
-INTEGER FUNCTION get_number_of_childs ()
+INTEGER FUNCTION get_number_of_childs ()     ! Change the name to "get_number_of_children"
 
    IMPLICIT NONE
@@ -4196,5 +2280,4 @@
     NULLIFY( p_2d )
     NULLIFY( i_2d )
-
 !
 !-- List of array names, which can be coupled
@@ -4286,5 +2369,4 @@
     INTEGER(iwp) ::  child_id    !<
     INTEGER(iwp) ::  m           !<
-
     REAL(wp) ::  waittime        !<
 
@@ -4324,5 +2406,4 @@
     INTEGER(iwp) ::  k          !< 
     INTEGER(iwp) ::  n          !< running index for chemical species
-
     REAL(wp) ::  waittime       !<
 
@@ -4350,60 +2431,34 @@
 !
 !--    The interpolation.
-       CALL pmci_interp_1sto_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,   &
-                                   r2yo, r1zo, r2zo, kcto, iflu, ifuu,         &
-                                   jflo, jfuo, kflo, kfuo, ijkfc_u, 'u' )
-       CALL pmci_interp_1sto_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,   &
-                                   r2yv, r1zo, r2zo, kcto, iflo, ifuo,         &
-                                   jflv, jfuv, kflo, kfuo, ijkfc_v, 'v' )
-       CALL pmci_interp_1sto_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,   &
-                                   r2yo, r1zw, r2zw, kctw, iflo, ifuo,         &
-                                   jflo, jfuo, kflw, kfuw, ijkfc_w, 'w' )
-
-       IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.          &
-            (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.           &
+       CALL pmci_interp_1sto_all ( u, uc, kcto, iflu, ifuu, jflo, jfuo, kflo, kfuo, 'u' )
+       CALL pmci_interp_1sto_all ( v, vc, kcto, iflo, ifuo, jflv, jfuv, kflo, kfuo, 'v' )
+       CALL pmci_interp_1sto_all ( w, wc, kctw, iflo, ifuo, jflo, jfuo, kflw, kfuw, 'w' )
+
+       IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.                              &
+            (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                               &
                .NOT. constant_diffusion ) )  THEN
-          CALL pmci_interp_1sto_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, &
-                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,       &
-                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 'e' )
+          CALL pmci_interp_1sto_all ( e, ec, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 'e' )
        ENDIF
 
        IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
-          CALL pmci_interp_1sto_all ( diss,  dissc,  ico, jco, kco, r1xo, r2xo,&
-                                      r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,&
-                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+          CALL pmci_interp_1sto_all ( diss, dissc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
        ENDIF
 
        IF ( .NOT. neutral )  THEN
-          CALL pmci_interp_1sto_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,      &
-                                      r1yo, r2yo, r1zo, r2zo, kcto, iflo, ifuo,&
-                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+          CALL pmci_interp_1sto_all ( pt, ptc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
        ENDIF
 
        IF ( humidity )  THEN
 
-          CALL pmci_interp_1sto_all ( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo, &
-                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
-                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+          CALL pmci_interp_1sto_all ( q, q_c, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
 
           IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
-             CALL pmci_interp_1sto_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,   &
-                                         r1yo, r2yo, r1zo, r2zo, kcto,         &
-                                         iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
-                                         ijkfc_s, 's' ) 
-             CALL pmci_interp_1sto_all ( nc, ncc, ico, jco, kco, r1xo, r2xo,   &
-                                         r1yo, r2yo, r1zo, r2zo, kcto,         &
-                                         iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
-                                         ijkfc_s, 's' )   
+             CALL pmci_interp_1sto_all ( qc, qcc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' ) 
+             CALL pmci_interp_1sto_all ( nc, ncc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )   
           ENDIF
 
           IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
-             CALL pmci_interp_1sto_all ( qr, qrc, ico, jco, kco, r1xo, r2xo,   &
-                                         r1yo, r2yo, r1zo, r2zo, kcto,         &
-                                         iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
-                                         ijkfc_s, 's' )
-             CALL pmci_interp_1sto_all ( nr, nrc, ico, jco, kco, r1xo, r2xo,   &
-                                         r1yo, r2yo, r1zo, r2zo, kcto,         &
-                                         iflo, ifuo, jflo, jfuo, kflo, kfuo,   &
-                                         ijkfc_s, 's' )
+             CALL pmci_interp_1sto_all ( qr, qrc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
+             CALL pmci_interp_1sto_all ( nr, nrc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
           ENDIF
 
@@ -4411,16 +2466,11 @@
 
        IF ( passive_scalar )  THEN
-          CALL pmci_interp_1sto_all ( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,  &
-                                      r2yo, r1zo, r2zo, kcto, iflo, ifuo,      &
-                                      jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+          CALL pmci_interp_1sto_all ( s, sc, kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
        ENDIF
 
        IF ( air_chemistry  .AND.  nest_chemistry )  THEN
           DO  n = 1, nspec
-             CALL pmci_interp_1sto_all ( chem_species(n)%conc,                 &
-                                         chem_spec_c(:,:,:,n),                 &
-                                         ico, jco, kco, r1xo, r2xo, r1yo,      &
-                                         r2yo, r1zo, r2zo, kcto, iflo, ifuo,   &
-                                         jflo, jfuo, kflo, kfuo, ijkfc_s, 's' )
+             CALL pmci_interp_1sto_all ( chem_species(n)%conc, chem_spec_c(:,:,:,n),                &
+                                         kcto, iflo, ifuo, jflo, jfuo, kflo, kfuo, 's' )
           ENDDO
        ENDIF
@@ -4460,43 +2510,21 @@
 
 
-    SUBROUTINE pmci_interp_1sto_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,    &
-                                     r1z, r2z, kct, ifl, ifu, jfl, jfu,        &
-                                     kfl, kfu, ijkfc, var )
+    SUBROUTINE pmci_interp_1sto_all( f, fc, kct, ifl, ifu, jfl, jfu, kfl, kfu, var )
 !
 !--    Interpolation of the internal values for the child-domain initialization
        IMPLICIT NONE
 
-       CHARACTER(LEN=1), INTENT(IN) :: var  !<
-
-       INTEGER(iwp), DIMENSION(nxlfc:nxrfc), INTENT(IN)         ::  ic    !<
-       INTEGER(iwp), DIMENSION(nysfc:nynfc), INTENT(IN)         ::  jc    !<
-!AH       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !<
-       INTEGER(iwp), DIMENSION(nzb:nzt+kgsr), INTENT(IN)        ::  kc    !<
-
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !<
-       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc       !<
-       REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  :: r1x   !<
-       REAL(wp), DIMENSION(nxlfc:nxrfc), INTENT(IN)  :: r2x   !<
-       REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  :: r1y   !<
-       REAL(wp), DIMENSION(nysfc:nynfc), INTENT(IN)  :: r2y   !<
-       REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) :: r1z   !<
-       REAL(wp), DIMENSION(nzb:nzt+kgsr), INTENT(IN) :: r2z   !<
-
-       INTEGER(iwp) :: kct
-!AH       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
-!AH       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
-!AH       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-!AH       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f  !< Child-grid array 
+       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc        !< Parent-grid array
+       INTEGER(iwp) :: kct                                    !< The parent-grid index in z-direction just below the boundary value node
        INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl !< Indicates start index of child cells belonging to certain parent cell - x direction
        INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu !< Indicates end index of child cells belonging to certain parent cell - x direction
        INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfl !< Indicates start index of child cells belonging to certain parent cell - y direction
-       INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates start index of child cells belonging to certain parent cell - y direction
+       INTEGER(iwp), DIMENSION(jcsa:jcna), INTENT(IN) ::  jfu !< Indicates end index of child cells belonging to certain parent cell - y direction
        INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfl !< Indicates start index of child cells belonging to certain parent cell - z direction
-       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu !< Indicates start index of child cells belonging to certain parent cell - z direction
-!AH
-!       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-       INTEGER(iwp), DIMENSION(0:cg%nz+1,jcsa:jcna,icla:icra), INTENT(IN) :: ijkfc !< number of child grid points contributing to a parent grid box
-!AH
-
+       INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu !< Indicates end index of child cells belonging to certain parent cell - z direction
+       CHARACTER(LEN=1), INTENT(IN) :: var                    !< Variable symbol: 'u', 'v', 'w' or 's'
+!
+!--    Local variables:
        INTEGER(iwp) ::  i        !<
        INTEGER(iwp) ::  ib       !<
@@ -4517,5 +2545,4 @@
        INTEGER(iwp) ::  me       !<
        INTEGER(iwp) ::  n        !<
-       INTEGER(iwp) ::  var_flag !<
 
 
@@ -4558,16 +2585,5 @@
              jlast = nyn + 1
           ENDIF
-       ENDIF
-!
-!--    Is masking needed here, think about it.
-       IF ( var == 'u' )  THEN 
-          var_flag = 1 
-       ELSEIF ( var == 'v' )  THEN
-          var_flag = 2 
-       ELSEIF ( var == 'w' )  THEN
-          var_flag = 3
-       ELSE
-          var_flag = 0
-       ENDIF       
+       ENDIF      
 
        f(:,:,:) = 0.0_wp
@@ -5044,34 +3060,12 @@
           IF ( bc_dirichlet_l )  THEN
 
-             CALL pmci_interp_1sto_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
-                                       r1yo, r2yo, r1zo, r2zo,                  &
-                                       logc_u_l, logc_ratio_u_l,                &
-                                       logc_kbounds_u_l, nzt_topo_nestbc_l,     &
-                                       kcto, iflu, ifuu, jflo, jfuo, kflo,      &
-                                       kfuo, ijkfc_u, 'l', 'u' )
-
-             CALL pmci_interp_1sto_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
-                                       r1yv, r2yv, r1zo, r2zo,                  &
-                                       logc_v_l, logc_ratio_v_l,                &
-                                       logc_kbounds_v_l, nzt_topo_nestbc_l,     &
-                                       kcto, iflo, ifuo, jflv, jfuv, kflo,      &
-                                       kfuo, ijkfc_v, 'l', 'v' )
-
-             CALL pmci_interp_1sto_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
-                                       r1yo, r2yo, r1zw, r2zw,                  &
-                                       logc_w_l, logc_ratio_w_l,                &
-                                       logc_kbounds_w_l, nzt_topo_nestbc_l,     &
-                                       kctw, iflo, ifuo, jflo, jfuo, kflw,      &
-                                       kfuw, ijkfc_w, 'l', 'w' )
-
-             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   &
-                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
+             CALL pmci_interp_1sto_lr( u, uc, kcto, jflo, jfuo, kflo, kfuo, 'l', 'u' )
+             CALL pmci_interp_1sto_lr( v, vc, kcto, jflv, jfuv, kflo, kfuo, 'l', 'v' )
+             CALL pmci_interp_1sto_lr( w, wc, kctw, jflo, jfuo, kflw, kfuw, 'l', 'w' )
+
+             IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.                        &
+                  (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.                         &
                      .NOT. constant_diffusion ) )  THEN
-!                CALL pmci_interp_1sto_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
-!                                          r1yo, r2yo, r1zo, r2zo,              &
-!                                          logc_w_l, logc_ratio_w_l,            &
-!                                          logc_kbounds_w_l, nzt_topo_nestbc_l, &
-!                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
-!                                          kfuo, ijkfc_s, 'l', 'e' )
+!                CALL pmci_interp_1sto_lr( e, ec, kcto, jflo, jfuo, kflo, kfuo, 'l', 'e' )
 !
 !--             Interpolation of e is replaced by the Neumann condition. 
@@ -5083,64 +3077,23 @@
 
              IF ( rans_mode_parent  .AND.  rans_mode  .AND.  rans_tke_e )  THEN
-                CALL pmci_interp_1sto_lr( diss,  dissc,  ico, jco, kco, r1xo,  &
-                                          r2xo, r1yo, r2yo, r1zo, r2zo,        &
-                                          logc_w_l, logc_ratio_w_l,            &
-                                          logc_kbounds_w_l, nzt_topo_nestbc_l, &
-                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
-                                          kfuo, ijkfc_s, 'l', 's' )
+                CALL pmci_interp_1sto_lr( diss, dissc, kcto, jflo, jfuo, kflo, kfuo, 'l', 's' )
              ENDIF
 
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_1sto_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
-                                          r1yo, r2yo, r1zo, r2zo,              &
-                                          logc_w_l, logc_ratio_w_l,            &
-                                          logc_kbounds_w_l, nzt_topo_nestbc_l, &
-                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
-                                          kfuo, ijkfc_s, 'l', 's' )
+                CALL pmci_interp_1sto_lr( pt, ptc, kcto, jflo, jfuo, kflo, kfuo, 'l', 's' )
              ENDIF
 
              IF ( humidity )  THEN
 
-                CALL pmci_interp_1sto_lr( q, q_c, ico, jco, kco, r1xo, r2xo,   &
-                                          r1yo, r2yo, r1zo, r2zo,              &
-                                          logc_w_l, logc_ratio_w_l,            &
-                                          logc_kbounds_w_l, nzt_topo_nestbc_l, &
-                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
-                                          kfuo, ijkfc_s, 'l', 's' )
+                CALL pmci_interp_1sto_lr( q, q_c, kcto, jflo, jfuo, kflo, kfuo, 'l', 's' )
 
                 IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
-                   CALL pmci_interp_1sto_lr( qc, qcc, ico, jco, kco, r1xo,     &
-                                             r2xo, r1yo, r2yo, r1zo, r2zo,     &
-                                             logc_w_l, logc_ratio_w_l,         &
-                                             logc_kbounds_w_l,                 &
-                                             nzt_topo_nestbc_l,                &
-                                             kcto, iflo, ifuo, jflo, jfuo,     &
-                                             kflo, kfuo, ijkfc_s, 'l', 's' )  
-
-                   CALL pmci_interp_1sto_lr( nc, ncc, ico, jco, kco, r1xo,     &
-                                             r2xo, r1yo, r2yo, r1zo, r2zo,     &
-                                             logc_w_l, logc_ratio_w_l,         &
-                                             logc_kbounds_w_l,                 &
-                                             nzt_topo_nestbc_l,                &
-                                             kcto, iflo, ifuo, jflo, jfuo,     &
-                                             kflo, kfuo, ijkfc_s, 'l', 's' )          
+                   CALL pmci_interp_1sto_lr( qc, qcc, kcto, jflo, jfuo, kflo, kfuo, 'l', 's' )  
+                   CALL pmci_interp_1sto_lr( nc, ncc, kcto, jflo, jfuo, kflo, kfuo, 'l', 's' )          
                 ENDIF
 
                 IF ( bulk_cloud_model  .AND.  microphysics_seifert )  THEN
-                   CALL pmci_interp_1sto_lr( qr, qrc, ico, jco, kco, r1xo,     &
-                                             r2xo, r1yo, r2yo, r1zo, r2zo,     &
-                                             logc_w_l, logc_ratio_w_l,         &
-                                             logc_kbounds_w_l,                 &
-                                             nzt_topo_nestbc_l,                &
-                                             kcto, iflo, ifuo, jflo, jfuo,     &
-                                             kflo, kfuo, ijkfc_s, 'l', 's' ) 
-
-                   CALL pmci_interp_1sto_lr( nr, nrc, ico, jco, kco, r1xo,     &
-                                             r2xo, r1yo, r2yo, r1zo, r2zo,     &
-                                             logc_w_l, logc_ratio_w_l,         &
-                                             logc_kbounds_w_l,                 &
-                                             nzt_topo_nestbc_l,                &
-                                             kcto, iflo, ifuo, jflo, jfuo,     &
-                                             kflo, kfuo, ijkfc_s, 'l', 's' )             
+                   CALL pmci_interp_1sto_lr( qr, qrc, kcto, jflo, jfuo, kflo, kfuo, 'l', 's' ) 
+                   CALL pmci_interp_1sto_lr( nr, nrc, kcto, jflo, jfuo, kflo, kfuo, 'l', 's' )             
                 ENDIF
 
